<div dir="rtl" markdown="1">

**בשפה העברית**
* [המדריך המלא למתחילים](he-il/newbs.md)
  * [מקורות ללמידה](he-il/newbs_learn_more_resources.md)
* [בסיס QMK](he-il/README.md)
    * [מבוא לQMK](he-il/getting_started_introduction.md)
    * [איך להשתמש בGithub](he-il/getting_started_github.md)
    * [קבלת עזרה](he-il/getting_started_getting_help.md)
* [שאלות נפוצות](he-il/faq.md)
    * [שאלות נפוצות כלליות](he-il/faq_general.md)
* [חומרה](he-il/hardware.md)
* התייחסויות
  * [איך לתעד נכון](he-il/documentation_best_practices.md)

**בשפה האנגלית**
* [המדריך המלא למתחילים](he-il/newbs.md)
  * [התחלה](he-il/newbs_getting_started.md)
  * [בנייה של הקושחה הראשונה שלך](he-il/newbs_building_firmware.md)
  * [צריבה של הקושחה](he-il/newbs_flashing.md)
  * [בדיקות ודיבאגינג](he-il/newbs_testing_debugging.md)
  * [עבודה נכונה ב GIT](he-il/newbs_best_practices.md)
  * [מקורות ללמידה](he-il/newbs_learn_more_resources.md)

* [בסיס QMK](he-il/README.md)
  * [מבוא לQMK](he-il/getting_started_introduction.md)
  * [QMK CLI](he-il/cli.md)
  * [QMK CLI Config](he-il/cli_configuration.md)
  * [תרומה ל QMK](he-il/contributing.md)
  * [איך להשתמש בGithub](he-il/getting_started_github.md)
  * [קבלת עזרה](he-il/getting_started_getting_help.md)

* [שינויים משמעותיים](he-il/breaking_changes.md)
  * [2019 Aug 30](he-il/ChangeLog/20190830.md)

* [שאלות נפוצות](he-il/faq.md)
  * [שאלות נפוצות כלליות](he-il/faq_general.md)
  * [בנייה/קומפילציה של QMK](he-il/faq_build.md)
  * [דיבאגינג ופתרון תקלות של QMK](he-il/faq_debug.md)
  * [מיפוי מקשים](he-il/faq_keymap.md)
  * [התקנת דרייברים עם Zadig](he-il/driver_installation_zadig.md)

* מדריכים מפורטים
  * [התקנת כלי Build](he-il/getting_started_build_tools.md)
  * [מדריך Vagrant](he-il/getting_started_vagrant.md)
  * [הוראות בנייה/קומפילציה](he-il/getting_started_make_guide.md)
  * [צריבת קושחה](he-il/flashing.md)
  * [התאמה אישית של הפונקציונאליות](he-il/custom_quantum_functions.md)
  * [מיפוי מקשים](he-il/keymap.md)

* [חומרה](he-il/hardware.md)
  * [מעבדי AVR](he-il/hardware_avr.md)
  * [דרייברים](he-il/hardware_drivers.md)

* התייחסויות
  * [מדריך למקלדות](he-il/hardware_keyboard_guidelines.md)
  * [אפשרויות הגדרות](he-il/config_options.md)
  * [קודי מקשים](he-il/keycodes.md)
  * [קונבנציות קוד - C](he-il/coding_conventions_c.md)
  * [קונבנציות קוד - Python](he-il/coding_conventions_python.md)
  * [איך לתעד נכון](he-il/documentation_best_practices.md)
  * [טמפלטים לדוקומנטציה](he-il/documentation_templates.md)
  * [מילון](he-il/reference_glossary.md)
  * [בדיקות יחידה](he-il/unit_testing.md)
  * [פונקציות שימושיות](he-il/ref_functions.md)
  * [תמיכה בConfigurator](he-il/reference_configurator_support.md)
  * [פורמט info.json](he-il/reference_info_json.md)
  * [פיתוח בPython CLI](he-il/cli_development.md)

* [תכונות](he-il/features.md)
  * [Basic Keycodes](he-il/keycodes_basic.md)
  * [US ANSI Shifted Keys](he-il/keycodes_us_ansi_shifted.md)
  * [Quantum Keycodes](he-il/quantum_keycodes.md)
  * [Advanced Keycodes](he-il/feature_advanced_keycodes.md)
  * [Audio](he-il/feature_audio.md)
  * [Auto Shift](he-il/feature_auto_shift.md)
  * [Backlight](he-il/feature_backlight.md)
  * [Bluetooth](he-il/feature_bluetooth.md)
  * [Bootmagic](he-il/feature_bootmagic.md)
  * [Combos](he-il/feature_combo.md)
  * [Command](he-il/feature_command.md)
  * [Debounce API](he-il/feature_debounce_type.md)
  * [DIP Switch](he-il/feature_dip_switch.md)
  * [Dynamic Macros](he-il/feature_dynamic_macros.md)
  * [Encoders](he-il/feature_encoders.md)
  * [Grave Escape](he-il/feature_grave_esc.md)
  * [Haptic Feedback](he-il/feature_haptic_feedback.md)
  * [HD44780 LCD Controller](he-il/feature_hd44780.md)
  * [Key Lock](he-il/feature_key_lock.md)
  * [Layouts](he-il/feature_layouts.md)
  * [Leader Key](he-il/feature_leader_key.md)
  * [LED Matrix](he-il/feature_led_matrix.md)
  * [Macros](he-il/feature_macros.md)
  * [Mouse Keys](he-il/feature_mouse_keys.md)
  * [OLED Driver](he-il/feature_oled_driver.md)
  * [One Shot Keys](he-il/feature_advanced_keycodes.md#one-shot-keys)
  * [Pointing Device](he-il/feature_pointing_device.md)
  * [PS/2 Mouse](he-il/feature_ps2_mouse.md)
  * [RGB Lighting](he-il/feature_rgblight.md)
  * [RGB Matrix](he-il/feature_rgb_matrix.md)
  * [Space Cadet](he-il/feature_space_cadet.md)
  * [Split Keyboard](he-il/feature_split_keyboard.md)
  * [Stenography](he-il/feature_stenography.md)
  * [Swap Hands](he-il/feature_swap_hands.md)
  * [Tap Dance](he-il/feature_tap_dance.md)
  * [Terminal](he-il/feature_terminal.md)
  * [Thermal Printer](he-il/feature_thermal_printer.md)
  * [Unicode](he-il/feature_unicode.md)
  * [Userspace](he-il/feature_userspace.md)
  * [Velocikey](he-il/feature_velocikey.md)

* למייקרים ומודרים
  * [מדריך לכתיבה ידנית](he-il/hand_wire.md)
  * [מדריך לצריבת ISP](he-il/isp_flashing_guide.md)
  * [מדריך לדיבאגינג ARM](he-il/arm_debugging.md)
  * [מנהל התקן I2C](he-il/i2c_driver.md)
  * [בקרת GPIO](he-il/internals_gpio_control.md)
  * [המרת Proton C](he-il/proton_c_conversion.md)

* להבנה עמוקה יותר
  * [איך עובדות מקלדות](he-il/how_keyboards_work.md)
  * [להבין את QMK](he-il/understanding_qmk.md)

* נושאים נוספים
  * [שימוש ב - Eclipse עם QMK](he-il/other_eclipse.md)
  * [שימוש ב - VSCode עם QMK](he-il/other_vscode.md)
  * [תמיכה](he-il/support.md)
  * [כיצד להוסיף תרגום](he-il/translating.md)

* QMK מבפנים (בתהליך)
  * [Defines](he-il/internals_defines.md)
  * [Input Callback Reg](he-il/internals_input_callback_reg.md)
  * [Midi Device](he-il/internals_midi_device.md)
  * [Midi Device Setup Process](he-il/internals_midi_device_setup_process.md)
  * [Midi Util](he-il/internals_midi_util.md)
  * [Send Functions](he-il/internals_send_functions.md)
  * [Sysex Tools](he-il/internals_sysex_tools.md)

</div>
