* [完全菜鸟指南](zh-cn/newbs.md)
  * [入门](zh-cn/newbs_getting_started.md)
  * [构建你的第一个固件](zh-cn/newbs_building_firmware.md)
  * [刷新固件](zh-cn/newbs_flashing.md)
  * [测试和调试](zh-cn/newbs_testing_debugging.md)
  * [Git最佳实践](zh-cn/newbs_best_practices.md)
  * [学习资源](zh-cn/newbs_learn_more_resources.md)

* [QMK基础](zh-cn/README.md)
  * [QMK简介](zh-cn/getting_started_introduction.md)
  * [向QMK贡献](zh-cn/contributing.md)
  * [如何使用Github](zh-cn/getting_started_github.md)
  * [获得帮助](zh-cn/getting_started_getting_help.md)

* [问题解答](zh-cn/faq.md)
  * [一般问题](zh-cn/faq_general.md)
  * [构建/编译](zh-cn/faq_build.md)
  * [调试/故障排除](zh-cn/faq_debug.md)
  * [键盘映射](zh-cn/faq_keymap.md)

* 详细指南
  * [安装构建工具](zh-cn/getting_started_build_tools.md)
  * [vagrant指南](zh-cn/getting_started_vagrant.md)
  * [构建/编译指令](zh-cn/getting_started_make_guide.md)
  * [刷新固件](zh-cn/flashing.md)
  * [定制功能](zh-cn/custom_quantum_functions.md)
  * [映射概述](zh-cn/keymap.md)

* [硬件](zh-cn/hardware.md)
  * [AVR处理器](zh-cn/hardware_avr.md)
  * [驱动](zh-cn/hardware_drivers.md)

* 参考
  * [键盘指南](zh-cn/hardware_keyboard_guidelines.md)
  * [配置选项](zh-cn/config_options.md)
  * [键码](zh-cn/keycodes.md)
  * [记录最佳实践](zh-cn/documentation_best_practices.md)
  * [文档模板](zh-cn/documentation_templates.md)
  * [术语表](zh-cn/reference_glossary.md)
  * [单元测试](zh-cn/unit_testing.md)
  * [有用的功能](zh-cn/ref_functions.md)
  * [配置器支持](zh-cn/reference_configurator_support.md)
  * [info.json 格式](zh-cn/reference_info_json.md)

* [特性](zh-cn/features.md)
  * [基本键码](zh-cn/keycodes_basic.md)
  * [US ANSI控制码](zh-cn/keycodes_us_ansi_shifted.md)
  * [量子键码](zh-cn/quantum_keycodes.md)
  * [高级键码](zh-cn/feature_advanced_keycodes.md)
  * [音频](zh-cn/feature_audio.md)
  * [自动shift](zh-cn/feature_auto_shift.md)
  * [背光](zh-cn/feature_backlight.md)
  * [蓝牙](zh-cn/feature_bluetooth.md)
  * [热改键](zh-cn/feature_bootmagic.md)
  * [组合](zh-cn/feature_combo)
  * [命令](zh-cn/feature_command.md)
  * [拨动开关](zh-cn/feature_dip_switch.md)
  * [动态宏指令](zh-cn/feature_dynamic_macros.md)
  * [编码器](zh-cn/feature_encoders.md)
  * [重音号Esc复合键](zh-cn/feature_grave_esc.md)
  * [自锁键](zh-cn/feature_key_lock.md)
  * [布局](zh-cn/feature_layouts.md)
  * [前导键](zh-cn/feature_leader_key.md)
  * [LED阵列](zh-cn/feature_led_matrix.md)
  * [宏指令](zh-cn/feature_macros.md)
  * [鼠标键](zh-cn/feature_mouse_keys.md)
  * [一键功能](zh-cn/feature_advanced_keycodes.md#one-shot-keys)
  * [指针设备](zh-cn/feature_pointing_device.md)
  * [PS/2鼠标](zh-cn/feature_ps2_mouse.md)
  * [RGB灯光](zh-cn/feature_rgblight.md)
  * [RGB矩阵](zh-cn/feature_rgb_matrix.md)
  * [空格候补换挡](zh-cn/feature_space_cadet.md)
  * [速录机](zh-cn/feature_stenography.md)
  * [换手](zh-cn/feature_swap_hands.md)
  * [多击键](zh-cn/feature_tap_dance.md)
  * [终端](zh-cn/feature_terminal.md)
  * [热敏打印机](zh-cn/feature_thermal_printer.md)
  * [Unicode](zh-cn/feature_unicode.md)
  * [用户空间](zh-cn/feature_userspace.md)
  * [速度键](zh-cn/feature_velocikey.md)

* 针对制造者和定制者
  * [手工连线指南](zh-cn/hand_wire.md)
  * [ISP刷新指南](zh-cn/isp_flashing_guide.md)
  * [ARM调试指南](zh-cn/arm_debugging.md)
  * [I2C驱动](zh-cn/i2c_driver.md)
  * [GPIO控制器](zh-cn/internals_gpio_control.md)
  * [Proton C转换](zh-cn/proton_c_conversion.md)

* 深入了解
  * [键盘如何工作](zh-cn/how_keyboards_work.md)
  * [理解QMK](zh-cn/understanding_qmk.md)

* 其他话题
  * [使用Eclipse开发QMK](zh-cn/other_eclipse.md)
  * [使用VSCode开发QMK](zh-cn/other_vscode.md)
  * [支持](zh-cn/support.md)

* QMK 内构 (正在编写)
  * [定义](zh-cn/internals_defines.md)
  * [输入回调寄存器](zh-cn/internals_input_callback_reg.md)
  * [Midi设备](zh-cn/internals_midi_device.md)
  * [Midi设备设置过程](zh-cn/internals_midi_device_setup_process.md)
  * [Midi工具库](zh-cn/internals_midi_util.md)
  * [发送函数](zh-cn/internals_send_functions.md)
  * [Sysex工具](zh-cn/internals_sysex_tools.md)
