# MCU name
MCU = atmega32u4

# Bootloader selection
#   Teensy       halfkay
#   Pro Micro    caterina
#   Atmel DFU    atmel-dfu
#   LUFA DFU     lufa-dfu
#   QMK DFU      qmk-dfu
#   ATmega32A    bootloadHID
#   ATmega328P   USBasp
BOOTLOADER = caterina

# Build Options
#   comment out to disable the options.
#
CUSTOM_MATRIX           = yes # Custom matrix file for the ErgoDone
UNICODE_ENABLE          = yes # Unicode
BOOTMAGIC_ENABLE        = yes	# Virtual DIP switch configuration(+1000)
MOUSEKEY_ENABLE         = yes	# Mouse keys(+4700)
EXTRAKEY_ENABLE         = yes	# Audio control and System control(+450)
CONSOLE_ENABLE          = no	# Console for debug(+400)
COMMAND_ENABLE          = no  # Commands for debug and configuration
SLEEP_LED_ENABLE        = no  # Breathing sleep LED during USB suspend
NKRO_ENABLE             = yes	# USB Nkey Rollover - not yet supported in LUFA
USB_6KRO_ENABLE         = no  # USB 6key Rollover
BACKLIGHT_ENABLE        = no	# Enable keyboard backlight functionality
KEYMAP_IN_EEPROM_ENABLE = no 	# External keymap in eeprom
KEYMAP_SECTION_ENABLE   = no	# Fixed address keymap for keymap editor
SOFTPWM_LED_ENABLE      = no  # Enable SoftPWM to drive backlight
FADING_LED_ENABLE       = no  # Enable fading backlight
BREATHING_LED_ENABLE    = no  # Enable breathing backlight
LEDMAP_ENABLE           = no	# Enable LED mapping
LEDMAP_IN_EEPROM_ENABLE = no  # Read LED mapping from eeprom
SWAP_HANDS_ENABLE       = no  # Disable Onehand
RGBLIGHT_ENABLE         = no
MIDI_ENABLE             = no

# project specific files
SRC = \
    twimaster.c \
	  matrix.c    \
    expander.c  \

LAYOUTS = ergodox
