# Overview

* Base layer uses the Balance Twelve layout ([reference](https://mathematicalmulticore.wordpress.com/the-keyboard-layout-project/))
* Plover layer uses the same home position as the base layer ([reference](http://www.openstenoproject.org/))

## To build

```
make planck/rev6:yttyx
```

## To build and flash

```
make planck/rev6:yttyx:dfu-util
```

## Layers

### Base

    .--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.
    | P      | L      | C      | D      | W      |        |        | U      | O      | Y      | K      | Q      |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | N      | R      | S      | T      | M      |        | BS     | A      | E      | I      | H      | V      |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | Z Sft  | J      | F      | G      | B      |        | Ent    | ' @    | , <    | . >    | X Sft  |        |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | Ctl    | Alt    | Sup    | NP     | Spc    | Esc/FC | Sft    | Sft    | Sup    | Alt    | Ctl    |        |
    '--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'

### Plover

    .--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.
    | #      | #      | #      | #      | #      | BA     | #      | #      | #      | #      | #      | #      |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | S      | T      | P      | H      | *      |        | *      | F      | P      | L      | T      | D      |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | S      | K      | W      | R      | *      |        | *      | R      | B      | G      | S      | Z      |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    |        |        |        | A      | O      |        | E      | U      |        |        |        |        |
    '--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'

### Numeric/Punctuation

    .--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.
    | 1 !    | 2 "    | 3 £    | 4 $    | 5 %    | PL     |        | 6 ^    | 7 &    | 8 *    | 9 (    | 0 )    |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | Tab    | Ctl-X  | Ctl-C  | Ctl-V  | Ctl-Z  |        | BS     | [ {    | ] }    | - _    | ; :    | \ |    |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | Sft    |        |        | Del    | Ins    |        |        | / ?    | = +    | # ~    | `      |        |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | Ctl    | Alt    | Sup    | NP     | Spc    |        | Sft    | Sft    | Sup    | Alt    | Ctl    |        |
    '--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'

### Function

    .--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.--------.
    | F1     | F2     | F3     | F4     | F5     |        |        | Home   | Up     | End    | PgUp   |        |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | F6     | F7     | F8     | F9     | F10    |        |        | Left   | Down   | Right  | PgDn   |        |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | Sft    |        |        | F11    | F12    |        |        | PScr   | Break  | ScLk   | Caps   |        |
    |--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------+--------|
    | Ctl    | Alt    | Sup    |        | Spc    |        | Sft    | Sft    | Sup    | Alt    | Ctl    |        |
    '--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'--------'


